<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Util\Utilities;

class FctSignatariospadrWidgetController extends SMCrud {
    
    protected $dataSourceName = "fct_signatariospadr_widget";
    
    public function __construct($crudService, $environment) {
        parent::__construct($crudService, $environment);
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            parent::find($request, $response);
            $erro = $response->getError();
            if ($erro) {
                throw new \Exception($erro->getMessage(), $erro->getErrorCode());
            }
                
            $rows = $response->getDataSets()[0]->getRows();
            foreach ($rows as &$row) {
                $row["OPERADORES"] = Utilities::getArrayDeString($row["OPERADORES"]);
            }
            unset($row);
            
            $response->setDataSets(array(new DataSet($this->dataSourceName, $rows)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

?>