<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00015000ApropriacaoRecursosFactory {
    
    protected $connection;
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
     /**
     * Atualizando no banco o campo da tabela de apropriação com as
     * horas que foram excluidas ou adicionadas
     */
    public function atualizarQtdHorasApropriadas($params){
        $sql = "UPDATE FCT_APROPAGENDAMENTO
                   SET QTHORASAPROPRIADAS = (SELECT SUM(QTTEMPOAPONT)
                                              FROM FCT_APONTAMENTOAPROPAGEN
                                             WHERE IDTIPOAPONTAMENTO = '1'
                                               AND NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                                               AND NRORG              = :NRORG)
                 WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                   AND NRORG              = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
     /**
     * Retorna as horas apropriada para atuliza na tela
     */
    public function getQtdHorasApropriadas($params){
        $sql = "SELECT QTHORASAPROPRIADAS,
                      HORADEC_HORACHAR(QTHORASAPROPRIADAS) AS QTHORAS
                FROM FCT_APROPAGENDAMENTO 
                    WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                    AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
     /**
     * Atualizando no banco o campo da tabela de apropriação com as
     * horas que foram excluidas ou adicionadas
     */
    public function atualizarSituacaoDoRecurso($params){
        $sql = "UPDATE FCT_APROPAGENDAMENTO
                    SET IDSTATUSAPROPRIACAO = 2
                    WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                    AND NRORG              = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
     /**
     * Retorna as horas apropriada para atuliza na tela
     */
    public function getSituacaoDoApontamento($params){
        $sql = "SELECT IDSTATUSAPROPRIACAO
                FROM FCT_APROPAGENDAMENTO 
                    WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                    AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}

?>