<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00031000MapaRecursosAgendadosFactory {
    
    protected $connection;
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
   
    /**
    *  A função que busca o recursos agendados para ser mostrados no Swipe para cada marcador no mapa.
    * Têm com entrada o local de atendimento retorna os recursos deste local 
    */
    
    public function getRecursos($params){
        
        $sql = "SELECT
    PARC.NMPRINCIPALPARC AS NMRECURSO,
                PARC.NRORG,
                CONT.NRCONTRATOFCT || ' - ' || CONT.DSREFERENCIACONT AS AGENDAMENTO
            FROM
                FCT_RECURSOSAGENDCONT RECU
                INNER JOIN FCT_AGENDRECURSOCONT AGEN ON RECU.NRAGENDRECURSOCONT = AGEN.NRAGENDRECURSOCONT
                                                        AND RECU.NRORG = AGEN.NRORG
                INNER JOIN FCT_CONTRATO CONT
                ON AGEN.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND AGEN.NRORG = CONT.NRORG
                INNER JOIN FCT_CONTRATO CONT ON AGEN.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                                                AND AGEN.NRORG = CONT.NRORG
                INNER JOIN ESTRUTURAM LOCAL ON AGEN.NRESTRUTURAM = LOCAL.NRESTRUTURAM
                                               AND AGEN.NRORG = LOCAL.NRORG
                INNER JOIN PARCNEGOCIO PARC ON RECU.NRPARCNEPESSOA = PARC.NRPARCNEGOCIO
                                               AND RECU.NRORG = PARC.NRORG
            WHERE
                AGEN.NRESTRUTURAM =:NRESTRUTURAM
                AND 
                CONT.NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}

?>