/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: UPDATE_ITEM_VENDAMSDE

DESCRIO:
   Procedimento para agrupar produtos iguais, no mesmo intervalo de data em uma s nota fiscal.

CRIAO:
   16/12/2005 - Wander Alex

@c:\web_575\sql\end_conv\oracle\5504_DFSSTPO_UpDate_Item_VendaMSDE.SQL
RAISE_APPLICATION_ERROR(-20501,, TRUE);

*/

CREATE OR REPLACE PROCEDURE UPDATE_ITEM_VENDAMSDE
   (P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
    P_CDLOJA     IN VENDA.CDLOJA%TYPE,
    P_DTINICIAL  IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_DTFINAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_CDCAIXA    IN VARCHAR2,
    P_LISTAVENDA IN VARCHAR2,
    P_CDFILIPROC IN NOTAFISCAL.CDFILIAL%TYPE,
    P_DSMENSAGEM IN VARCHAR2,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDCONTADOR IN NUMBER)
AS
   V_DSDADOADIC   DADOSADIC.DSDADOADIC%TYPE;
   V_NRDADOADIC   DADOSADIC.NRDADOADIC%TYPE;
   V_IDTIPORECE   TIPORECE.IDTIPORECE%TYPE;
   V_DSMENSCPFCUP   CAIXA.DSMENSCPFCUP%TYPE;
   V_DSMENSDADOADIC   DADOSADIC.DSDADOADIC%TYPE;
   V_DSMD5FORSALE   PARAVEND.DSMD5FORSALE%TYPE;
   V_NRDADOADICAUX  DADOSADIC.NRDADOADIC%TYPE;

   CURSOR C_ITEMVENDA IS
      SELECT V.CDFILIALIMP AS CDFILIAL, V.NRSEQVENIMP AS NRSEQVENDA, V.CDCAIXAIMP AS CDCAIXA, V.CDLOJAIMP AS CDLOJA,
             V.DTENTRVENIMP AS DTENTRVENDA, P.CDPRODUTO, P.NMPRODUTO,
             P.CDARVPROD, P.CDPRODESTO, V.NRCUPFISIMP AS NRCUPOMFIS,
             (V.VRUNITVENIMP + NVL(V.VRUNITVECIMP,0)) AS VRUNITVEND,
             V.DSMARCAECFIMP, V.DSMODELOECFIMP, V.NRSERIEIMPIMP,
             SUM(V.QTPRODVENIMP) AS QTPRODVEND,
             NVL(SUM(V.VRDESITVEIMP),0) AS VRDESITVEND,
             SUM((V.QTPRODVENIMP * (V.VRUNITVENIMP + NVL(V.VRUNITVECIMP,0))) - NVL(V.VRDESITVEIMP,0)) AS VRTOTAITEM
        FROM VENDAAUX V, PRODUTO P
       WHERE (V.CDFILIALIMP  = P_CDFILIAL)       AND
             (V.CDLOJAIMP    = P_CDLOJA)         AND
             (V.CDPRODIMP    = P.CDPRODUTO)      AND
             (V.DTENTRVENIMP BETWEEN P_DTINICIAL  AND P_DTFINAL) AND
             ((INSTR(P_CDCAIXA, V.CDCAIXAIMP) > 0)  OR (P_CDCAIXA IS NULL)) AND
             ((P_LISTAVENDA IS NULL) OR (INSTR(P_LISTAVENDA, V.CDFILIALIMP||V.CDCAIXAIMP||V.NRSEQVENIMP) > 0))
       GROUP BY V.CDFILIALIMP,   V.NRSEQVENIMP, V.NRCUPFISIMP,
             V.CDCAIXAIMP,    V.CDLOJAIMP,     V.DTENTRVENIMP,
             P.CDPRODUTO,  P.NMPRODUTO,  P.CDARVPROD,
             P.CDPRODESTO, V.VRUNITVENIMP, V.DSMARCAECFIMP,
             V.DSMODELOECFIMP, V.NRSERIEIMPIMP, V.VRUNITVECIMP;
BEGIN                                                          
   V_DSDADOADIC := '';

   SELECT NVL(MAX(NRDADOADIC), '0')
     INTO V_NRDADOADIC
     FROM DADOSADIC
    WHERE CDFILIAL   = P_CDFILIPROC
      AND NRLANCTONF = P_NRLANCTONF;

   V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');

   SELECT DSMD5FORSALE
     INTO V_DSMD5FORSALE
     FROM PARAVEND
    WHERE CDFILIAL = P_CDFILIPROC;

   IF (V_DSMD5FORSALE IS NOT NULL) THEN
      SELECT MAX(NRDADOADIC)
        INTO V_NRDADOADICAUX
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC
         AND NRLANCTONF = P_NRLANCTONF
         AND INSTR(DSDADOADIC, 'Cdigo MD5') >= 1;

      IF (V_NRDADOADICAUX IS NULL) THEN
         INSERT INTO DADOSADIC
         (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
         (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, 'Cdigo MD5: ' || V_DSMD5FORSALE);

         V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');
      END IF;
   END IF;

   FOR C_GERANF IN C_ITEMVENDA LOOP
      /*Atualizao da Tabela ITEMVENDA*/
      UPDATE ITEMVENDA
         SET CDFILIALNF  = P_CDFILIPROC,
             NRLANCTONF  = P_NRLANCTONF,
             NRSEQITPROD = LPAD(TO_CHAR(P_CDCONTADOR),4,'0')
       WHERE (CDFILIAL     = C_GERANF.CDFILIAL)   AND
             (CDCAIXA      = C_GERANF.CDCAIXA)    AND
             (NRSEQVENDA   = C_GERANF.NRSEQVENDA) AND
             (CDPRODUTO    = C_GERANF.CDPRODUTO)  AND
             ((VRUNITVEND + NVL(VRUNITVENDCL,0)) = C_GERANF.VRUNITVEND);
             
      IF V_NRDADOADIC <= '998' THEN
         V_DSDADOADIC := P_DSMENSAGEM || C_GERANF.NRCUPOMFIS ||
                         ' (COO: ' || SUBSTR(C_GERANF.NRCUPOMFIS, 1, 6) ||
                         ', Marca: ' || SUBSTR(C_GERANF.DSMARCAECFIMP, 1, 15) ||
                         ', Mod: ' || SUBSTR(C_GERANF.DSMODELOECFIMP, 1, 15) ||
                         ', N: ' || C_GERANF.NRSERIEIMPIMP ||
                         ')';

         SELECT MAX(NRDADOADIC)
           INTO V_NRDADOADICAUX
           FROM DADOSADIC
          WHERE CDFILIAL   = P_CDFILIPROC
            AND NRLANCTONF = P_NRLANCTONF
            AND DSDADOADIC = V_DSDADOADIC;

         IF (V_NRDADOADICAUX IS NULL) THEN
            INSERT INTO DADOSADIC
               (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
            VALUES
               (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, V_DSDADOADIC);

            V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');
         END IF;
      END IF;
   END LOOP;

   V_DSDADOADIC := '';

   SELECT MAX(C.DSMENSCPFCUP)
     INTO V_DSMENSCPFCUP
     FROM CAIXA C
    WHERE C.CDFILIAL = P_CDFILIAL AND
          C.CDCAIXA = (SELECT MIN(CDCAIXA)
                         FROM CAIXA
                        WHERE CDFILIAL = P_CDFILIAL AND
                              ((INSTR(P_CDCAIXA, CDCAIXA) > 0)  OR (P_CDCAIXA IS NULL)) AND
                              DSMENSCPFCUP IS NOT NULL);

    SELECT MAX(DSDADOADIC)
      INTO V_DSMENSDADOADIC
      FROM DADOSADIC
     WHERE CDFILIAL   = P_CDFILIPROC AND
           NRLANCTONF = P_NRLANCTONF AND
           DSDADOADIC = V_DSMENSCPFCUP;

   IF (V_DSMENSDADOADIC IS NULL) AND (V_DSMENSCPFCUP IS NOT NULL) THEN
      SELECT NVL(MAX(NRDADOADIC), '0')
        INTO V_NRDADOADIC
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC AND
             NRLANCTONF = P_NRLANCTONF;
            
      IF V_NRDADOADIC < '998' THEN
         INSERT INTO DADOSADIC
            (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
            (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, V_DSMENSCPFCUP);

         V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('UPDATE_ITEM_VENDAMSDE','5.75.xxx'); END;
/

