CREATE TABLE EXCP_RET_NF
AS SELECT * FROM RETORNO_PEDIDO_OC
    WHERE 1 = 2
/

ALTER TABLE EXCP_RET_NF
ADD EXCECAO VARCHAR2(4000)
/

/*
@C:\web_587\sql\end_conv\oracle\clientes\sap\1111_SAPSTPO_IMPORTA_RET_NF.sql
*/
create or replace PROCEDURE MHA_IMPORTA_RET_NOTAFISCAL(XML_ARQ IN CLOB,
                                     P_ERRO OUT VARCHAR2,
                                     P_SEQLOG NUMBER DEFAULT -1)
IS
   L_XMLTYPE XMLTYPE;

   V_CODPEDIDO VARCHAR2(30);
   V_EMPRESA   VARCHAR2(10);
   V_FILIAL    VARCHAR2(10);
   V_CODAGENTE VARCHAR2(30);
   V_DATAINCL  VARCHAR2(19);
   V_NFENTRADA VARCHAR2(30);
   V_NRSERIE   VARCHAR2(30);
   V_CDARVPROD VARCHAR2(30);
   V_QTDE      FLOAT;

   /* VALIDACAO ITEMPRODUTO */
   V_CDFILIAL  VARCHAR2(4);
   V_NRLANCTO  VARCHAR2(10);
   V_QTITEMPROD FLOAT;
   V_CDPRODEMIS   VARCHAR2(20);
   V_DSPRODEMIS   VARCHAR2(400);
   V_CDALMOXARIFE VARCHAR2(6);
   V_CDLOCALESTOQ VARCHAR2(6);
   V_VRUNITITEM   FLOAT;
   V_VRDESCITEM   FLOAT;
   V_NRLOTEESTQ   VARCHAR2(20);
   V_NRSUBLOTE    VARCHAR2(4);
   V_CDPRODESTO   VARCHAR2(10);

   /* VALIDACAO PRODUTO */
   V_CDPRODUTO VARCHAR2(10);
   V_DIFERENCA FLOAT;

   /* DEVOLUCAO */
   V_QTDEVOLUCAO FLOAT;
   V_QTDEESTO FLOAT;

   V_CDFILIALOL VARCHAR2(4);
   V_CDFORNECED VARCHAR2(21);

   V_CDFILIALDEVO VARCHAR2(4);
   V_NRLANCTODEVO VARCHAR2(12);
   V_NRLANCESTQ VARCHAR2(20);
   V_NRLANCDEVO VARCHAR2(20);

   /*VARIVEIS ROTINA DE REMESSA*/
   /*SADA*/
   V_NFS_NRLANCTO    VARCHAR2(20);
   V_NFS_CDFILIAL    VARCHAR2(04);
   V_NFS_NRLANCESTQ  VARCHAR2(20);
   V_CDINSCESTAREM  VARCHAR2(16);
   V_CDFILWMSMHAARM VARCHAR2(04);
   V_CDEMPRESAREM   VARCHAR2(10);
   V_NFS_SERIE      VARCHAR2(05);

   /*ENTRADA*/
   V_NFE_NRLANCTO    VARCHAR2(20);
   V_NFE_CDFILIAL    VARCHAR2(04);
   V_NFE_NRLANCESTQ  VARCHAR2(20);
   V_NFE_SERIE       VARCHAR2(05);
   V_NFE_CDEMPRESA   VARCHAR2(02);
   V_CDGRUPOFISC     VARCHAR2(03);
   V_INTEREST        VARCHAR2(01);
   V_NFE_VRNOTAFISC  FLOAT;

   V_VRCUSTOPROD     FLOAT;
   V_TIPOCUSTO       INTEGER;
   V_DTPOSEST        DATE;
   V_NRDECITOTANF    FLOAT;

   V_CONTROLE VARCHAR2(14);

   V_CDFILIRECE VARCHAR2(4);
   V_LANCESTNFANT VARCHAR2(10);
   V_NRACESSONFE VARCHAR2(44);
   V_CDINSCESTA VARCHAR2(16);
   V_CDINSCESTA_OL VARCHAR2(16);
   V_NRNOTAFISC VARCHAR2(20);
   V_VRPRODUTOS FLOAT;
   V_ERRO VARCHAR2(4000);
   V_XMLTYPE XMLTYPE;

   V_SEQITEM VARCHAR2(10);
   V_CODPRODUTO VARCHAR2(30);
   V_QUANTIDADE FLOAT;
   V_CODUNIDADE VARCHAR2(30);
   V_IDNFDEVOOL VARCHAR2(5);
   V_CDTIPOOPER VARCHAR2(2);
   V_IDENTRSAIDOP VARCHAR2(2);
   V_TABELA VARCHAR2(50);
   V_DATA VARCHAR2(20);
   V_IDORIGDESTNF VARCHAR2(2);
   V_CDFILIEMIT VARCHAR2(4);

   V_SEQLOGITEM NUMBER;
   V_CONT       INTEGER;

   CURSOR C_XML IS (SELECT EMPRESA, FILIAL, DATAINCLUSAO, CODPEDIDOCOMPRA, CODAGENTE, NFENTRADA, NFSERIE, SEQITEM, CODPRODUTO, QUANTIDADE, CODUNIDADE
                      FROM RETORNO_PEDIDO_OC);

   CURSOR C_PROD_ATU(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
      SELECT IP.NRSEQITPROD, IP.CDPRODUTO, IP.QTITEMPROD, NVL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE, NVL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
             NF.CDTIPOOPER
        FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF, NOTAFISCAL NF
       WHERE IP.CDFILIAL   = NF.CDFILIAL
         AND IP.NRLANCTONF = NF.NRLANCTONF
         AND P.CDPRODUTO   = IP.CDPRODUTO
         AND PF.CDPRODUTO  = P.CDPRODESTO
         AND IP.CDFILIAL   = C_CDFILIAL
         AND IP.NRLANCTONF = C_NRLANCTONF
         AND NVL(IDCNTRESTOQ, 'S') = 'S';

   PROCEDURE INSERE_LOGITEM(P_SEQLOGITEM OUT NUMBER)
   IS
   BEGIN
      IF (P_SEQLOG > -1) THEN
         SELECT MAX(SEQLOGITEM)+1
           INTO P_SEQLOGITEM
           FROM USR_LOGITEM_INTEGRACAO;
         BEGIN
            INSERT INTO USR_LOGITEM_INTEGRACAO(SEQLOG, SEQLOGITEM, CDDADOS, HORAENV, HORAREC)
            VALUES(P_SEQLOG, P_SEQLOGITEM, V_CODPEDIDO,  SYSDATE, SYSDATE);
         EXCEPTION
            WHEN OTHERS THEN
               P_SEQLOGITEM := 0;
         END;
      ELSE
         P_SEQLOGITEM := 0;
      END IF;
   END;
BEGIN
   V_CONTROLE := ' ';
   DELETE FROM RETORNO_PEDIDO_OC;
   L_XMLTYPE := XMLTYPE(XML_ARQ);
   V_TABELA := 'Retorno Nota Fiscal';
   V_CODPEDIDO := 'ERRO';

   FOR C_XML IN (SELECT EXTRACTVALUE(VALUE(P), '/Pedido/EMPRESA/text()') AS EMPRESA
                        ,EXTRACTVALUE(VALUE(P), '/Pedido/FILIAL/text()') AS FILIAL
                        ,EXTRACTVALUE(VALUE(P), '/Pedido/DATAINCLUSAO/text()') AS DATAINCLUSAO
                        ,EXTRACTVALUE(VALUE(P), '/Pedido/CODPEDIDOCOMPRA/text()') AS CODPEDIDOCOMPRA
                        ,EXTRACTVALUE(VALUE(P), '/Pedido/CODAGENTE/text()') AS CODAGENTE
                        ,EXTRACTVALUE(VALUE(P), '/Pedido/NFENTRADA/text()') AS NFENTRADA
                        ,EXTRACTVALUE(VALUE(P), '/Pedido/NFSERIE/text()') AS NFSERIE
                        ,EXTRACT(VALUE(P), '/Pedido/ItensNF/ItensNF/ITEMItensNF') AS ITENS
                   FROM TABLE(XMLSEQUENCE(EXTRACT(L_XMLTYPE, '//Pedido'))) P)
   LOOP
       --'2017-06-01T00:00:00-03:00' Exemplo da data que esta chegando
      V_DATA := TO_CHAR(TO_DATE(SUBSTR(C_XML.DATAINCLUSAO, 1, 10), 'YYYY-MM-DD'), 'DD/MM/YYYY');

      FOR C_ITENS IN (SELECT EXTRACTVALUE(VALUE(ITENS), '/ITEMItensNF/SEQITEM/text()') AS SEQUENCIAL
                            ,EXTRACTVALUE(VALUE(ITENS), '/ITEMItensNF/CODPRODUTO/text()') AS CODPRODUTO
                            ,EXTRACTVALUE(VALUE(ITENS), '/ITEMItensNF/QUANTIDADE/text()') AS QUANTIDADE
                            ,EXTRACTVALUE(VALUE(ITENS), '/ITEMItensNF/CODUNIDADE/text()') AS CODUNIDADE
                        FROM TABLE(XMLSEQUENCE(EXTRACT(C_XML.ITENS, '/ITEMItensNF'))) ITENS)
      LOOP
         INSERT INTO RETORNO_PEDIDO_OC(EMPRESA, FILIAL, DATAINCLUSAO, CODPEDIDOCOMPRA, CODAGENTE, NFENTRADA, NFSERIE,
                                       SEQITEM, CODPRODUTO, QUANTIDADE, CODUNIDADE)
         VALUES(C_XML.EMPRESA, C_XML.FILIAL, V_DATA, C_XML.CODPEDIDOCOMPRA, C_XML.CODAGENTE, C_XML.NFENTRADA, C_XML.NFSERIE, C_ITENS.SEQUENCIAL,
                C_ITENS.CODPRODUTO, C_ITENS.QUANTIDADE, C_ITENS.CODUNIDADE);
      END LOOP;
   END LOOP;

   COMMIT;

   OPEN C_XML;
   LOOP
      FETCH C_XML INTO V_EMPRESA, V_FILIAL, V_DATAINCL, V_CODPEDIDO, V_CODAGENTE, V_NFENTRADA, V_NRSERIE,
                       V_SEQITEM, V_CDARVPROD, V_QUANTIDADE, V_CODUNIDADE;

      -- FECHA A NOTA SE NÿO HOUVEREM ERROS OU SE TIVER CHEGADO AO ÚLTIMO REGISTRO SEM ERROS
      IF (((V_CONTROLE <> V_CODPEDIDO) AND (V_NRLANCESTQ IS NOT NULL)) OR ((C_XML%NOTFOUND) AND (V_NRLANCESTQ IS NOT NULL))) THEN
         IF (V_CONT > 0) THEN
            INSERT INTO ITEMNOTAFISC(CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
            VALUES(V_CDFILIALDEVO, V_NRLANCDEVO, LPAD(1, 3, '0'), V_CDFILIAL, V_NRLANCTO);

            BEGIN
               GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIAL   => V_CDFILIALDEVO,
                                          P_NRLANCTONF => V_NRLANCDEVO,
                                          P_NRLANCESTQ => V_NRLANCESTQ);
            EXCEPTION
               WHEN OTHERS THEN
                  ROLLBACK;
                  V_ERRO := SQLERRM(SQLCODE);
                  INSERE_LOGITEM(V_SEQLOGITEM);

                  IF V_SEQLOGITEM != 0 THEN
                     INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                     VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                  END IF;

                  COMMIT;
            END;

            IF (V_ERRO IS NULL) THEN
               ATUALIZA_ESTOQUE(V_CDFILIALOL, TO_DATE(V_DATAINCL), TO_DATE(SYSDATE), V_CDFILIALDEVO, V_NRLANCESTQ);

               /* Atualizar a Itlanctoest para não evoluir estoque caso encontre erro ao atualizar o estoque */
               FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                          CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                     FROM MOVILOTE
                                    WHERE NRMOVILOTE = V_CDFILIALDEVO||V_NRLANCESTQ
                                      AND CDFILIAL   = V_CDFILIALOL) LOOP
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ  = 'N'
                   WHERE CDFILIAL     = V_CDFILIALDEVO
                     AND NRLANCESTQ   = V_NRLANCESTQ
                     AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                     AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                     AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                     AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

                  V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
               END LOOP;

               DELETE MOVILOTE
                WHERE NRMOVILOTE = V_CDFILIALDEVO||V_NRLANCESTQ;

               UPDATE NOTAFISCAL
                  SET USR_DTEXPXML = SYSDATE
                WHERE CDFILIAL     = V_CDFILIALDEVO
                  AND NRLANCTONF   = V_NRLANCDEVO;

               /* Gerar retorno referente a devoluo efetuada ao fornecedor (Saida da filial 3967 e entrada na filial 3966)*/
               SELECT CDFILWMSMHAARM
                 INTO V_CDFILWMSMHAARM
                 FROM PARAMFILIAL
                WHERE CDFILIAL = V_CDFILIALOL;

               IF (V_CDFILWMSMHAARM IS NOT NULL) AND (V_ERRO IS NULL) THEN
                  NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILWMSMHAARM, V_NFS_NRLANCTO);
                  NOVO_CODIGO_SC('LANCTOEST'    ||V_CDFILWMSMHAARM, V_NFS_NRLANCESTQ);

                  V_NFS_NRLANCTO   := SUBSTR(V_NFS_NRLANCTO,   -10);
                  V_NFS_NRLANCESTQ := SUBSTR(V_NFS_NRLANCESTQ, -10);

                  SELECT CDSERIE, CDINSCESTA
                    INTO V_NFS_SERIE, V_CDINSCESTAREM
                    FROM FILIAL
                   WHERE CDFILIAL = V_CDFILWMSMHAARM;

                  /* Gera corpo nota fiscal de sada */
                  BEGIN
                     GERA_NOTAFISCAL_CORPO(P_CDFILIAL    => V_CDFILWMSMHAARM,
                                           P_CDFILIEMIT  => V_CDFILWMSMHAARM,
                                           P_CDEMPRESA   => V_CDEMPRESAREM,
                                           P_CDTIPOOPER  => '94',
                                           P_DTENTRSAID  => TO_DATE(V_DATAINCL),
                                           P_IDSISTEMA   => 'DFS',
                                           P_PRXLANCTONF => V_NFS_NRLANCTO,
                                           P_PRXLANCESTQ => V_NFS_NRLANCESTQ,
                                           P_CDSERIE     => V_NFS_SERIE,
                                           P_CDCLIENTE   => V_CDFILIALOL,
                                           P_NRLANCTONF  => V_NFS_NRLANCTO,
                                           P_NRLANCESTQ  => V_NFS_NRLANCESTQ);
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_NFS_NRLANCESTQ := NULL;
                        ROLLBACK;
                        V_ERRO := SQLERRM(SQLCODE);
                        INSERE_LOGITEM(V_SEQLOGITEM);

                        IF V_SEQLOGITEM != 0 THEN
                           INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                           VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                        END IF;

                        COMMIT;
                  END;


                  -- Buscar itens da NF de devoluo para gerao do Retorno
                  FOR C_PRODREM IN (SELECT IP.CDPRODUTO,    IP.CDPRODEMIS, IP.DSPRODEMIS,
                                           IP.VRUNITITEM,   IP.VRDESCITEM, IP.CDALMOXARIFE,
                                           IP.CDLOCALESTOQ, IP.NRLOTEESTQ, IP.NRSUBLOTE,
                                           IP.QTITEMPROD,   P.CDPRODESTO
                                      FROM ITEMPRODUTO IP, PRODUTO P
                                     WHERE IP.CDFILIAL   = V_CDFILIALDEVO
                                       AND IP.NRLANCTONF = V_NRLANCDEVO
                                       AND IP.CDPRODUTO  = P.CDPRODUTO) LOOP

                     SELECT MAX(TO_NUMBER(CDTIPOCUSTO))
                       INTO V_TIPOCUSTO
                       FROM TIPOOPERAC
                      WHERE CDTIPOOPER = '94';

                     IF (V_TIPOCUSTO IS NULL) THEN
                        SELECT MAX(TO_NUMBER(IDTCUSNFROMA))
                          INTO V_TIPOCUSTO
                          FROM PARAMFILIAL
                         WHERE CDFILIAL = V_CDFILWMSMHAARM;
                     END IF;

                     IF (V_TIPOCUSTO IS NULL) THEN
                        V_TIPOCUSTO := 3;
                     END IF;

                     SELECT MAX(DTPOSIESTQ) DTPOSIESTQ
                       INTO V_DTPOSEST
                       FROM POSESTDIA
                      WHERE (CDFILIAL     = V_CDFILWMSMHAARM)
                        AND (CDALMOXARIFE = ' ')
                        AND (CDLOCALESTOQ = ' ')
                        AND (NRLOTEESTQ   = ' ')
                        AND (NRSUBLOTE    = ' ')
                        AND (CDPRODUTO    = C_PRODREM.CDPRODESTO)
                        AND (DTPOSIESTQ  <= TO_DATE(V_DATAINCL) + 1);

                     IF (V_DTPOSEST IS NULL) THEN
                        V_DTPOSEST := TO_DATE(V_DATAINCL);
                     END IF;

                     BEGIN
                        SELECT NVL(CUSTO_PRODUTO_LCEST(V_CDFILWMSMHAARM, D.CDPRODUTO, V_TIPOCUSTO,  TO_DATE(V_DATAINCL), SYSDATE,
                                 D.CDALMOXARIFE, D.CDLOCALESTOQ, D.NRLOTEESTQ, D.NRSUBLOTE),0) * P.VRFATOCONV AS VRCUSTOPROD
                          INTO V_VRCUSTOPROD
                          FROM PRODUTO P, POSESTDIA D, LOTE L
                         WHERE (D.CDFILIAL     = V_CDFILWMSMHAARM)
                           AND (D.CDALMOXARIFE = ' ')
                           AND (D.CDLOCALESTOQ = ' ')
                           AND (P.CDPRODUTO    = C_PRODREM.CDPRODUTO)
                           AND (D.NRLOTEESTQ   = ' ')
                           AND (D.NRSUBLOTE    = ' ')
                           AND (DTPOSIESTQ     = V_DTPOSEST)
                           AND (D.CDPRODUTO    = P.CDPRODESTO)
                           AND (D.CDFILIAL     = L.CDFILIAL)
                           AND (D.NRLOTEESTQ   = L.NRLOTEESTQ)
                           AND (D.NRSUBLOTE    = L.NRSUBLOTE)
                           AND (D.CDPRODUTO    = L.CDPRODUTO);
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRCUSTOPROD := 0;
                     END;

                     SELECT NVL(MAX(NRDECITOTANF), 2)
                       INTO V_NRDECITOTANF
                       FROM PARAMGERAL;

                     IF (V_VRCUSTOPROD = 0) THEN
                        V_VRCUSTOPROD := C_PRODREM.VRUNITITEM;
                     ELSE
                        V_VRCUSTOPROD := ROUND(V_VRCUSTOPROD, V_NRDECITOTANF);
                     END IF;

                     BEGIN
                     GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_CDFILWMSMHAARM,
                                             P_NRLANCTONF   => V_NFS_NRLANCTO,
                                             P_CDPRODUTO    => C_PRODREM.CDPRODUTO,
                                             P_CDPRODEMIS   => C_PRODREM.CDPRODEMIS,
                                             P_DSPRODEMIS   => C_PRODREM.DSPRODEMIS,
                                             P_VRUNITITEM   => V_VRCUSTOPROD,
                                             P_VRDESCITEM   => C_PRODREM.VRDESCITEM,
                                             P_CDALMOXARIFE => C_PRODREM.CDALMOXARIFE,
                                             P_CDLOCALESTOQ => C_PRODREM.CDLOCALESTOQ,
                                             P_NRLOTEESTQ   => C_PRODREM.NRLOTEESTQ,
                                             P_NRSUBLOTE    => C_PRODREM.NRSUBLOTE,
                                             P_QTITEMPROD   => C_PRODREM.QTITEMPROD);
                     EXCEPTION
                        WHEN OTHERS THEN
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                           INSERE_LOGITEM(V_SEQLOGITEM);

                           IF V_SEQLOGITEM != 0 THEN
                              INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                              VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                           END IF;

                           COMMIT;
                     END;


                  END LOOP;
                 /* Relacionar a nf de retorno com a devoluo */
                 INSERT INTO RELACREMESSARET
                    (CDFILIALRET, NRLANCTONFRET, CDFILIALUTIL, NRLANCTONFUTIL)
                  VALUES
                    (V_CDFILWMSMHAARM, V_NFS_NRLANCTO, V_CDFILIALDEVO, V_NRLANCDEVO);

                  BEGIN
                     GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIAL   => V_CDFILWMSMHAARM,
                                                P_NRLANCTONF => V_NFS_NRLANCTO,
                                                P_NRLANCESTQ => V_NFS_NRLANCESTQ);
                  EXCEPTION
                     WHEN OTHERS THEN
                        ROLLBACK;
                        V_ERRO := SQLERRM(SQLCODE);
                        INSERE_LOGITEM(V_SEQLOGITEM);

                        IF V_SEQLOGITEM != 0 THEN
                           INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                           VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                        END IF;
                        COMMIT;
                  END;

                  IF (V_ERRO IS NULL) THEN
                     ATUALIZA_ESTOQUE(V_CDFILWMSMHAARM, TO_DATE(V_DATAINCL), TO_DATE(SYSDATE), V_CDFILWMSMHAARM, V_NFS_NRLANCESTQ);

                     /* Atualizar a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
                     FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                                CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                           FROM MOVILOTE
                                          WHERE NRMOVILOTE = V_CDFILWMSMHAARM||V_NFS_NRLANCESTQ
                                            AND CDFILIAL   = V_CDFILWMSMHAARM) LOOP
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ  = 'N'
                         WHERE CDFILIAL     = V_CDFILWMSMHAARM
                           AND NRLANCESTQ   = V_NFS_NRLANCESTQ
                           AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                           AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                           AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                           AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                           AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

                        V_ERRO := 'Nota Fiscal de Retorno sada. Algum(ns) produto(s) tornariam o estoque irregular.';
                     END LOOP;

                     DELETE MOVILOTE
                      WHERE NRMOVILOTE = V_CDFILWMSMHAARM||V_NFS_NRLANCESTQ;

                     --COMMIT;
                  END IF;
                  /* Gravar dados adicionais */
                  IF (V_ERRO IS NULL) THEN
                     FOR C_DADOSADIC IN (SELECT N.NRINSJURNF, N.NRNOTAFISC,
                                                T.NMTIPOOPER AS OPERACAO
                                           FROM NOTAFISCAL N, TIPOOPERAC T
                                          WHERE N.CDFILIAL     = V_CDFILIALDEVO
                                            AND N.NRLANCTONF   = V_NRLANCDEVO
                                            AND N.CDTIPOOPER   = T.CDTIPOOPER
                                            AND N.IDENTRSAIDOP = T.IDENTRSAIDOP) LOOP

                        BEGIN
                        GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    => V_CDFILWMSMHAARM,
                                                   P_NRLANCTONF  => V_NFS_NRLANCTO,
                                                   P_DTINICIO    => SYSDATE,
                                                   P_DTFINAL     => SYSDATE,
                                                   P_MENSAGEM    => 'NF de retorno referente a '||C_DADOSADIC.OPERACAO||
                                                                    ' ao fornecedor '||C_DADOSADIC.NRINSJURNF);

                        GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    => V_CDFILWMSMHAARM,
                                                   P_NRLANCTONF  => V_NFS_NRLANCTO,
                                                   P_DTINICIO    => SYSDATE,
                                                   P_DTFINAL     => SYSDATE,
                                                   P_MENSAGEM    => 'NO INCIDENCIA DO ICMS ART7, INCISO II DO RICMS/SP');
                        EXCEPTION
                           WHEN OTHERS THEN
                              ROLLBACK;
                              V_ERRO := SQLERRM(SQLCODE);
                              INSERE_LOGITEM(V_SEQLOGITEM);

                              IF V_SEQLOGITEM != 0 THEN
                                 INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                                 VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                              END IF;

                              COMMIT;
                        END;
                     END LOOP;

                  END IF;

                  /* Gerar entrada no OL */
                  IF (V_ERRO IS NULL) THEN
                     /* Gera corpo nota fiscal de Entrada */
                     NOVO_CODIGO_SC('LANCNFPROD/FILIAL' || V_CDFILIALOL, V_NFE_NRLANCTO);
                     NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILIALOL, V_NFE_NRLANCTO);
                     NOVO_CODIGO_SC('LANCTOEST'    ||V_CDFILIALOL, V_NFE_NRLANCESTQ);

                     V_NFE_NRLANCTO   := SUBSTR(V_NFE_NRLANCTO,   -10);
                     V_NFE_NRLANCESTQ := SUBSTR(V_NFE_NRLANCESTQ, -10);

                     SELECT CDSERIE, CDINSCESTA, CDEMPRESA
                       INTO V_NFE_SERIE, V_CDINSCESTAREM, V_NFE_CDEMPRESA
                       FROM FILIAL
                      WHERE CDFILIAL = V_CDFILIALOL;

                     SELECT VRNOTAFISC
                       INTO V_NFE_VRNOTAFISC
                       FROM NOTAFISCAL
                      WHERE CDFILIAL    = V_CDFILWMSMHAARM
                        AND NRLANCTONF  = V_NFS_NRLANCTO;

                     BEGIN
                        GERA_NOTAFISCAL_CORPO_ENTRADA (P_CDFILIAL    => V_CDFILIALOL,
                                                       P_CDFILIRECE  => V_CDFILIALOL,
                                                       P_CDEMPRESA   => V_NFE_CDEMPRESA,
                                                       P_CDTIPOOPER  => '94',
                                                       P_CDSERIEENTR => V_NFE_SERIE,
                                                       P_CDCLIENTE   => V_CDFILWMSMHAARM,
                                                       P_DTENTRSAID  => TO_DATE(V_DATAINCL),
                                                       P_IDSISTEMA   => 'DFE',
                                                       P_VRNOTAFISC  => V_NFE_VRNOTAFISC,
                                                       P_PRXLANCTONF => V_NFE_NRLANCTO,
                                                       P_PRXLANCESTQ => V_NFE_NRLANCESTQ,
                                                       P_NRLANCTONF  => V_NFE_NRLANCTO,
                                                       P_NRLANCESTQ  => V_NFE_NRLANCESTQ);

                     EXCEPTION
                        WHEN OTHERS THEN
                           V_NFS_NRLANCESTQ := NULL;
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                           INSERE_LOGITEM(V_SEQLOGITEM);

                           IF V_SEQLOGITEM != 0 THEN
                              INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                              VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                           END IF;

                           COMMIT;
                     END;

                     -- Buscar itens da NF de entrada para gerao da Remessa
                     FOR C_PRODREM IN (SELECT IP.CDPRODUTO,    IP.CDPRODEMIS, IP.DSPRODEMIS,
                                              IP.VRUNITITEM,   IP.VRDESCITEM, IP.CDALMOXARIFE,
                                              IP.CDLOCALESTOQ, IP.NRLOTEESTQ, IP.NRSUBLOTE,
                                              IP.QTITEMPROD,   P.CDPRODESTO
                                         FROM ITEMPRODUTO IP, PRODUTO P
                                        WHERE IP.CDFILIAL   = V_CDFILIALDEVO
                                          AND IP.NRLANCTONF = V_NRLANCDEVO
                                          AND IP.CDPRODUTO  = P.CDPRODUTO) LOOP

                        SELECT MAX(TO_NUMBER(CDTIPOCUSTO))
                          INTO V_TIPOCUSTO
                          FROM TIPOOPERAC
                         WHERE CDTIPOOPER = '94';

                        IF (V_TIPOCUSTO IS NULL) THEN
                           SELECT MAX(TO_NUMBER(IDTCUSNFROMA))
                             INTO V_TIPOCUSTO
                             FROM PARAMFILIAL
                            WHERE CDFILIAL = V_CDFILWMSMHAARM;
                        END IF;

                        IF (V_TIPOCUSTO IS NULL) THEN
                           V_TIPOCUSTO := 3;
                        END IF;

                        SELECT MAX(DTPOSIESTQ) DTPOSIESTQ
                          INTO V_DTPOSEST
                          FROM POSESTDIA
                         WHERE (CDFILIAL     = V_CDFILWMSMHAARM)
                           AND (CDALMOXARIFE = ' ')
                           AND (CDLOCALESTOQ = ' ')
                           AND (NRLOTEESTQ   = ' ')
                           AND (NRSUBLOTE    = ' ')
                           AND (CDPRODUTO    = C_PRODREM.CDPRODESTO)
                           AND (DTPOSIESTQ  <= TO_DATE(V_DATAINCL) + 1);

                        IF (V_DTPOSEST IS NULL) THEN
                           V_DTPOSEST := TO_DATE(V_DATAINCL);
                        END IF;

                        BEGIN
                           SELECT NVL(CUSTO_PRODUTO_LCEST(V_CDFILWMSMHAARM, D.CDPRODUTO, V_TIPOCUSTO,  TO_DATE(V_DATAINCL), SYSDATE,
                                    D.CDALMOXARIFE, D.CDLOCALESTOQ, D.NRLOTEESTQ, D.NRSUBLOTE),0) * P.VRFATOCONV AS VRCUSTOPROD
                             INTO V_VRCUSTOPROD
                             FROM PRODUTO P, POSESTDIA D, LOTE L
                            WHERE (D.CDFILIAL     = V_CDFILWMSMHAARM)
                              AND (D.CDALMOXARIFE = ' ')
                              AND (D.CDLOCALESTOQ = ' ')
                              AND (P.CDPRODUTO    = C_PRODREM.CDPRODUTO)
                              AND (D.NRLOTEESTQ   = ' ')
                              AND (D.NRSUBLOTE    = ' ')
                              AND (DTPOSIESTQ     = V_DTPOSEST)
                              AND (D.CDPRODUTO    = P.CDPRODESTO)
                              AND (D.CDFILIAL     = L.CDFILIAL)
                              AND (D.NRLOTEESTQ   = L.NRLOTEESTQ)
                              AND (D.NRSUBLOTE    = L.NRSUBLOTE)
                              AND (D.CDPRODUTO    = L.CDPRODUTO);
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_VRCUSTOPROD := 0;
                        END;

                        SELECT NVL(MAX(NRDECITOTANF), 2)
                          INTO V_NRDECITOTANF
                          FROM PARAMGERAL;

                        IF (V_VRCUSTOPROD = 0) THEN
                           V_VRCUSTOPROD := C_PRODREM.VRUNITITEM;
                        ELSE
                           V_VRCUSTOPROD := ROUND(V_VRCUSTOPROD, V_NRDECITOTANF);
                        END IF;

                        BEGIN
                        GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_CDFILIALOL,
                                                P_NRLANCTONF   => V_NFE_NRLANCTO,
                                                P_CDPRODUTO    => C_PRODREM.CDPRODUTO,
                                                P_CDPRODEMIS   => C_PRODREM.CDPRODEMIS,
                                                P_DSPRODEMIS   => C_PRODREM.DSPRODEMIS,
                                                P_VRUNITITEM   => V_VRCUSTOPROD,
                                                P_VRDESCITEM   => C_PRODREM.VRDESCITEM,
                                                P_QTITEMPROD   => C_PRODREM.QTITEMPROD);
                         EXCEPTION
                            WHEN OTHERS THEN
                               ROLLBACK;
                               V_ERRO := SQLERRM(SQLCODE);
                               INSERE_LOGITEM(V_SEQLOGITEM);

                               IF V_SEQLOGITEM != 0 THEN
                                  INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                                  VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                               END IF;

                               COMMIT;
                         END;
                     END LOOP;
                     -- Gravar impostos para os itens da nota fisca de entrada
                     FOR C_PRODREM IN (SELECT I.CDPRODUTO,  I.CDPRODEMIS,  I.DSPRODEMIS,
                                              I.VRUNITITEM, I.VRDESCITEM,  P.CDARVPROD,
                                              I.QTITEMPROD, I.NRSEQITPROD, I.VRTOTAITEM
                                         FROM ITEMPRODUTO I, PRODUTO P
                                        WHERE CDFILIAL    = V_CDFILIALOL
                                          AND NRLANCTONF  = V_NFE_NRLANCTO
                                          AND I.CDPRODUTO = P.CDPRODUTO) LOOP

                        CONSULTA_GRUPOFISCAL (P_IDORIGDESTNF => 'L',
                                              P_CDORIGDESTNF => V_CDFILIALOL,
                                              P_CDFILIFATUR  => V_CDFILIALOL,
                                              P_IDENTRSAIDOP => 'E',
                                              P_CDTIPOOPER   => '94',
                                              P_CDGRUPOFISC  => V_CDGRUPOFISC);

                        IMPOSTO_ENTRADA_PRODUTO(P_EMPRESA      => V_NFE_CDEMPRESA,
                                                P_INSCESTA     => V_CDINSCESTAREM,
                                                P_TIPOOPER     => '94',
                                                P_CDFORNECED   => '',
                                                P_FILIAL       => V_CDFILIALOL,
                                                P_LANCTONF     => V_NFE_NRLANCTO,
                                                P_INIVALID     => TO_DATE(V_DATAINCL),
                                                P_ENTRSAID     => 'E',
                                                P_CDGRUPOFISC  => V_CDGRUPOFISC,
                                                P_IDINTEREST   => 'N',
                                                P_CDARVPROD    => C_PRODREM.CDARVPROD,
                                                P_CDGRPFISCSV  => '',
                                                P_IDORIGDESTNF => 'L',
                                                P_CDFILIRECE   => V_CDFILIALOL,
                                                P_CDFILIEMIT   => V_CDFILWMSMHAARM,
                                                P_CDCLIENTE    => '',
                                                P_VRPRODUTO    => C_PRODREM.VRTOTAITEM);

                        FOR C_ALIQITEM IN(SELECT IM.CDIMPOSTO, IM.SGIMPOSTO, IM.IDTRATIMPO, IM.IDPREIMPENTR,
                                                 I.CDFISCTEMP, NVL(AL.VRALIQUTMP, 0) AS VRALIQUOTA
                                            FROM INCITEMP I, IMPOSTO IM, ALIQTEMPPROD AL
                                           WHERE I.CDIMPOTEMP  = IM.CDIMPOSTO
                                             AND I.NRINCITEMP  = V_CDFILIALOL||V_NFE_NRLANCTO
                                             AND I.NRINCITEMP  = AL.NRALIQTEMP(+)
                                             AND I.CDIMPOTEMP  = AL.CDIMPOTEMP(+)
                                             AND IM.IDPRODNOTA <> 'C') LOOP


                              INSERT INTO TRABITPROIMPOS
                                 (CDFILIMPOIT,  NRLANCIMPOIT,   NRSEQIMPOIT,   CDIMPOSTOIT,
                                  VRCONTIMPOIT, VRREDBCIMPOIT,  VRBCALCIMPOIT, VRALIQIMPOIT,
                                  VRPDEDIMPOIT, VRIMPOSIT,      CDFISCIMPOIT,  NRSEQITPRO,
                                  IDVALORINFO,  VR1REDBCIMPOIT, IDTRIMPSTTI,   VRIMPOSVISUIT)

                              VALUES
                                 (V_CDFILIALOL, V_NFE_NRLANCTO,  C_PRODREM.NRSEQITPROD, C_ALIQITEM.CDIMPOSTO,
                                 (C_PRODREM.VRTOTAITEM - C_PRODREM.VRDESCITEM), 0, C_PRODREM.VRTOTAITEM, C_ALIQITEM.VRALIQUOTA,
                                  0, 0, C_ALIQITEM.CDFISCTEMP, '1',
                                  'N', 0, '0', 0);

                        END LOOP;
                        DELETE
                          FROM ALIQTEMPPROD
                         WHERE NRALIQTEMP = V_CDFILIALOL||V_NFE_NRLANCTO;

                        DELETE
                          FROM INCITEMP
                         WHERE NRINCITEMP = V_CDFILIALOL||V_NFE_NRLANCTO;

                     END LOOP;

                     FOR C_TRABIMPOSNFTOT IN (SELECT SUM(T.VRIMPOSIT) VRTOTAIMPO, T.CDIMPOSTOIT
                                 FROM TRABITPROIMPOS T, IMPOSTO I
                                WHERE CDFILIMPOIT  = V_CDFILIALOL
                                  AND NRLANCIMPOIT = V_NFE_NRLANCTO
                                  AND IDPRODNOTA <> 'C'
                                  AND T.CDIMPOSTOIT = I.CDIMPOSTO
                                GROUP BY CDIMPOSTOIT
                                ORDER BY CDIMPOSTOIT)LOOP

                         INSERT INTO TRABIMPOSNFTOT
                                    (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT)

                              VALUES(V_CDFILIALOL, V_NFE_NRLANCTO, C_TRABIMPOSNFTOT.CDIMPOSTOIT, (0 + C_TRABIMPOSNFTOT.VRTOTAIMPO), 0);
                     END LOOP;

                     BEGIN
                        GERA_FECHAMENTO_NFENTRADA(P_CDFILIAL   => V_CDFILIALOL,
                                                  P_NRLANCTONF => V_NFE_NRLANCTO,
                                                  P_DATAPROC   => TO_DATE(V_DATAINCL),
                                                  P_NRLANCESTQ => V_NFE_NRLANCESTQ);
                     EXCEPTION
                        WHEN OTHERS THEN
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                           INSERE_LOGITEM(V_SEQLOGITEM);

                           IF V_SEQLOGITEM != 0 THEN
                              INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                              VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                           END IF;
                           COMMIT;
                     END;

                     IF (V_ERRO IS NULL) THEN
                        ATUALIZA_ESTOQUE(V_CDFILIALOL, TO_DATE(V_DATAINCL), TO_DATE(SYSDATE), V_CDFILIALOL, V_NFE_NRLANCESTQ);

                        /* Atualizar a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
                        FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                                   CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                              FROM MOVILOTE
                                             WHERE NRMOVILOTE = V_CDFILIALOL||V_NFE_NRLANCESTQ
                                               AND CDFILIAL   = V_CDFILIALOL) LOOP
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ  = 'N'
                            WHERE CDFILIAL     = V_CDFILIALOL
                              AND NRLANCESTQ   = V_NFE_NRLANCESTQ
                              AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                              AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                              AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                              AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                              AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

                           V_ERRO := 'Nota Fiscal de remessa entrada. Algum(ns) produto(s) tornariam o estoque irregular.';
                        END LOOP;

                        DELETE MOVILOTE
                         WHERE NRMOVILOTE = V_CDFILIALOL||V_NFE_NRLANCESTQ;

                     END IF;
                     /* Gravar documento de sada que deu origem a entrada*/
                     UPDATE NOTAFISCAL
                        SET IDDOCREPLIC = V_CDFILWMSMHAARM||V_NFS_NRLANCTO
                      WHERE CDFILIAL    = V_CDFILIALOL
                        AND NRLANCTONF  = V_NFE_NRLANCTO;
                     /* No grava dados adicionais da entrada do retorno */

                  END IF;
               END IF;
               /* Final Gera retorno referente a devoluo efetuada ao fornecedor (Saida da filial 3967 e entrada na filial 3966)*/
            END IF;


         ELSE
            ROLLBACK;
         END IF;
      END IF;

      EXIT WHEN C_XML%NOTFOUND;

      IF (V_CONTROLE <> V_CODPEDIDO) THEN
         V_CONTROLE := V_CODPEDIDO;
         V_ERRO     := NULL;
         V_CDFILIAL := SUBSTR(V_CODPEDIDO,1,4);
         V_NRLANCTO := SUBSTR(V_CODPEDIDO,-10);
         V_NRLANCDEVO := NULL;
         V_NRLANCESTQ := NULL;
         V_LANCESTNFANT := NULL;
         V_CONT := 0;

         BEGIN
            SELECT F.CDFILIAL
              INTO V_CDFILIALOL
              FROM FILIAL F JOIN PARAMFILIAL PF
                              ON F.CDFILIAL = PF.CDFILIAL
             WHERE PF.CDFILWMSMHA = V_FILIAL
               AND F.IDFUNCAOFILI = 'O';
         EXCEPTION
            WHEN OTHERS THEN
               V_TABELA := 'Retorno Nota Fiscal';
               V_CDFILIALOL := NULL;
               V_ERRO := 'No foi encontrado um operador logistico relacionada a empresa '||CHR(39)||V_EMPRESA||CHR(39)||', e a filial '||CHR(39)||V_FILIAL||CHR(39);
         END;

         IF (V_ERRO IS NULL) THEN
            BEGIN
               SELECT CDFILIRECE, NRNOTAFISC, NRACESSONFE, CDINSCESTA, VRPRODUTOS, IDNFDEVOOL, IDENTRSAIDOP, CDFORNECED, NVL(IDORIGDESTNF, 'F'), CDFILIEMIT, CDEMPRESA
                 INTO V_CDFILIRECE, V_NRNOTAFISC, V_NRACESSONFE, V_CDINSCESTA, V_VRPRODUTOS, V_IDNFDEVOOL, V_IDENTRSAIDOP, V_CDFORNECED, V_IDORIGDESTNF, V_CDFILIEMIT, V_CDEMPRESAREM
                 FROM NOTAFISCAL
                WHERE CDFILIAL   = V_CDFILIAL
                  AND NRLANCTONF = V_NRLANCTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDFILIRECE := NULL;
                  V_ERRO := 'Nota fiscal '||V_CODPEDIDO||' no encontrada';
            END;

            IF (V_CDFILIRECE IS NOT NULL) THEN
               IF (V_IDENTRSAIDOP = 'S') THEN
                  V_TABELA := 'Devoluo ao Fornecedor';
               ELSIF (V_IDENTRSAIDOP = 'E') AND (V_IDNFDEVOOL = 'S') THEN
                  V_TABELA := 'Devoluo ao OL';
               ELSE
                  V_TABELA := 'Ordem de Compra (NF)';
               END IF;

               UPDATE NOTAFISCAL
                  SET IDSTATUS   = 'P',
                      DTENTRSAID = TO_DATE(V_DATAINCL),
                      IDBLOQUEADO = 'S'
                WHERE CDFILIAL   = V_CDFILIAL
                  AND NRLANCTONF = V_NRLANCTO;

               UPDATE INTG_NOTAFISCAL
                  SET IDSTATUS = 'U'
                WHERE NRACESSONFE = V_NRACESSONFE;

               UPDATE NOTADESTINADA
                  SET CDFILIAL   = V_CDFILIAL,
                      NRLANCTONF = V_NRLANCTO,
                      CDINSCESTA = V_CDINSCESTA
                WHERE NRACESSONFE = V_NRACESSONFE;

               FOR C_ITENS IN (SELECT I.NRLANCESTQ, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ,
                                      I.NRSUBLOTE,    I.CDPRODMOVI,   I.DTLANCMOVI
                                 FROM ITLANCTOEST I, LANCTOESTOQ L
                                WHERE L.CDFILIAL   = V_CDFILIAL
                                  AND L.NRLANCTONF = V_NRLANCTO
                                  AND I.CDFILIAL   = L.CDFILIAL
                                  AND I.NRLANCESTQ = L.NRLANCESTQ)
               LOOP
                  DELETE CUSTOCMPPROD
                   WHERE CDFILLANCEST = V_CDFILIAL
                     AND CDALMOXARIFE = C_ITENS.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_ITENS.CDLOCALESTOQ
                     AND NRLOTEESTQ   = C_ITENS.NRLOTEESTQ
                     AND NRSUBLOTE    = C_ITENS.NRSUBLOTE
                     AND CDPRODUTO    = C_ITENS.CDPRODMOVI
                     AND DTCUSTCMPPRO = C_ITENS.DTLANCMOVI;

                  V_LANCESTNFANT := C_ITENS.NRLANCESTQ;
               END LOOP;

               UPDATE LANCTOESTOQ
                  SET DTLANCESTQ = TO_DATE(V_DATAINCL)
                WHERE CDFILIAL   = V_CDFILIAL
                  AND NRLANCESTQ = V_LANCESTNFANT;

               UPDATE ITLANCTOEST
                  SET IDEVOLESTOQ = 'S',
                      DTLANCMOVI  = TO_DATE(V_DATAINCL)
                WHERE CDFILIAL    = V_CDFILIAL
                  AND NRLANCESTQ  = V_LANCESTNFANT;

               CUSTO_LIQUIDO(V_CDFILIAL, V_LANCESTNFANT, V_VRPRODUTOS);

               ATUALIZA_ESTOQUE(V_CDFILIRECE, TO_DATE(V_DATAINCL), TO_DATE(SYSDATE), V_CDFILIAL, V_LANCESTNFANT);

               /* Atualizar a Itlanctoest para não evoluir estoque caso encontre erro ao atualizar o estoque */
               FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                          CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                     FROM MOVILOTE
                                    WHERE NRMOVILOTE = V_CDFILIAL||V_LANCESTNFANT
                                      AND CDFILIAL   = V_CDFILIRECE) LOOP
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ  = 'N'
                   WHERE CDFILIAL     = V_CDFILIAL
                     AND NRLANCESTQ   = V_LANCESTNFANT
                     AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                     AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                     AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                     AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;


                   V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
               END LOOP;

               DELETE MOVILOTE
                WHERE NRMOVILOTE = V_CDFILIAL||V_LANCESTNFANT;

               SELECT CDFILWMSMHAARM
                 INTO V_CDFILWMSMHAARM
                 FROM PARAMFILIAL
                WHERE CDFILIAL = V_CDFILIALOL;

               --Remessa de armazenagem
               IF (V_CDFILWMSMHAARM IS NOT NULL) AND (V_ERRO IS NULL) THEN
                  NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILIALOL, V_NFS_NRLANCTO);
                  NOVO_CODIGO_SC('LANCTOEST'    ||V_CDFILIALOL, V_NFS_NRLANCESTQ);

                  V_NFS_NRLANCTO   := SUBSTR(V_NFS_NRLANCTO,   -10);
                  V_NFS_NRLANCESTQ := SUBSTR(V_NFS_NRLANCESTQ, -10);

                  SELECT CDSERIE, CDINSCESTA
                    INTO V_NFS_SERIE, V_CDINSCESTAREM
                    FROM FILIAL
                   WHERE CDFILIAL = V_CDFILIALOL;

                  /* Gera corpo nota fiscal de sada */
                  BEGIN
                     GERA_NOTAFISCAL_CORPO(P_CDFILIAL    => V_CDFILIALOL,
                                           P_CDFILIEMIT  => V_CDFILIALOL,
                                           P_CDEMPRESA   => V_CDEMPRESAREM,
                                           P_CDTIPOOPER  => '93',
                                           P_DTENTRSAID  => TO_DATE(V_DATAINCL),
                                           P_IDSISTEMA   => 'DFS',
                                           P_PRXLANCTONF => V_NFS_NRLANCTO,
                                           P_PRXLANCESTQ => V_NFS_NRLANCESTQ,
                                           P_CDSERIE     => V_NFS_SERIE,
                                           P_CDCLIENTE   => V_CDFILWMSMHAARM,
                                           P_NRLANCTONF  => V_NFS_NRLANCTO,
                                           P_NRLANCESTQ  => V_NFS_NRLANCESTQ);
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_NFS_NRLANCESTQ := NULL;
                        ROLLBACK;
                        V_ERRO := SQLERRM(SQLCODE);
                        INSERE_LOGITEM(V_SEQLOGITEM);

                        IF V_SEQLOGITEM != 0 THEN
                           INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                           VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                        END IF;

                        COMMIT;
                  END;

                  -- Buscar itens da NF de entrada para gerao da Remessa
                  FOR C_PRODREM IN (SELECT CDPRODUTO,    CDPRODEMIS, DSPRODEMIS,
                                           VRUNITITEM,   VRDESCITEM, CDALMOXARIFE,
                                           CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,  QTITEMPROD
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL   = V_CDFILIAL
                                       AND NRLANCTONF = V_NRLANCTO) LOOP

                     BEGIN
                     GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_CDFILIALOL,
                                             P_NRLANCTONF   => V_NFS_NRLANCTO,
                                             P_CDPRODUTO    => C_PRODREM.CDPRODUTO,
                                             P_CDPRODEMIS   => C_PRODREM.CDPRODEMIS,
                                             P_DSPRODEMIS   => C_PRODREM.DSPRODEMIS,
                                             P_VRUNITITEM   => C_PRODREM.VRUNITITEM,
                                             P_VRDESCITEM   => C_PRODREM.VRDESCITEM,
                                             P_CDALMOXARIFE => C_PRODREM.CDALMOXARIFE,
                                             P_CDLOCALESTOQ => C_PRODREM.CDLOCALESTOQ,
                                             P_NRLOTEESTQ   => C_PRODREM.NRLOTEESTQ,
                                             P_NRSUBLOTE    => C_PRODREM.NRSUBLOTE,
                                             P_QTITEMPROD   => C_PRODREM.QTITEMPROD);
                     EXCEPTION
                        WHEN OTHERS THEN
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                           INSERE_LOGITEM(V_SEQLOGITEM);

                           IF V_SEQLOGITEM != 0 THEN
                              INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                              VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                           END IF;

                           COMMIT;
                     END;
                  END LOOP;
                 /* Relacionar a nf de compra com a remessa */

                  INSERT INTO RELACREMESSARET
                    (CDFILIALRET, NRLANCTONFRET, CDFILIALUTIL, NRLANCTONFUTIL)
                  VALUES
                    (V_CDFILIALOL, V_NFS_NRLANCTO, V_CDFILIAL, V_NRLANCTO);

                  BEGIN
                     GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIAL   => V_CDFILIALOL,
                                                P_NRLANCTONF => V_NFS_NRLANCTO,
                                                P_NRLANCESTQ => V_NFS_NRLANCESTQ);
                  EXCEPTION
                     WHEN OTHERS THEN
                        ROLLBACK;
                        V_ERRO := SQLERRM(SQLCODE);
                        INSERE_LOGITEM(V_SEQLOGITEM);

                        IF V_SEQLOGITEM != 0 THEN
                           INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                           VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                        END IF;
                        COMMIT;
                  END;

                  IF (V_ERRO IS NULL) THEN
                     ATUALIZA_ESTOQUE(V_CDFILIALOL, TO_DATE(V_DATAINCL), TO_DATE(SYSDATE), V_CDFILIALOL, V_NFS_NRLANCESTQ);

                     /* Atualizar a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
                     FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                                CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                           FROM MOVILOTE
                                          WHERE NRMOVILOTE = V_CDFILIALOL||V_NFS_NRLANCESTQ
                                            AND CDFILIAL   = V_CDFILIALOL) LOOP
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ  = 'N'
                         WHERE CDFILIAL     = V_CDFILIALOL
                           AND NRLANCESTQ   = V_NFS_NRLANCESTQ
                           AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                           AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                           AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                           AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                           AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

                        V_ERRO := 'Nota Fiscal de remessa sada. Algum(ns) produto(s) tornariam o estoque irregular.';
                     END LOOP;

                     DELETE MOVILOTE
                      WHERE NRMOVILOTE = V_CDFILIALOL||V_NFS_NRLANCESTQ;

                     --COMMIT;
                  END IF;
                  /* Gravar dados adicionais */
                  IF (V_ERRO IS NULL) THEN
                     FOR C_DADOSADIC IN (SELECT N.NRINSJURNF, N.NRNOTAFISC,
                                                T.NMTIPOOPER AS OPERACAO
                                           FROM NOTAFISCAL N, TIPOOPERAC T
                                          WHERE N.CDFILIAL     = V_CDFILIAL
                                            AND N.NRLANCTONF   = V_NRLANCTO
                                            AND N.CDTIPOOPER   = T.CDTIPOOPER
                                            AND N.IDENTRSAIDOP = T.IDENTRSAIDOP) LOOP

                        BEGIN
                        GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    => V_CDFILIALOL,
                                                   P_NRLANCTONF  => V_NFS_NRLANCTO,
                                                   P_DTINICIO    => SYSDATE,
                                                   P_DTFINAL     => SYSDATE,
                                                   P_MENSAGEM    => 'NF de remessa referente a '||C_DADOSADIC.OPERACAO||
                                                                    ' do fornecedor '||C_DADOSADIC.NRINSJURNF||
                                                                    ' NF: '||C_DADOSADIC.NRNOTAFISC);

                        GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    => V_CDFILIALOL,
                                                   P_NRLANCTONF  => V_NFS_NRLANCTO,
                                                   P_DTINICIO    => SYSDATE,
                                                   P_DTFINAL     => SYSDATE,
                                                   P_MENSAGEM    => 'NO INCIDENCIA DO ICMS ART7, INCISO II DO RICMS/SP');

                        EXCEPTION
                           WHEN OTHERS THEN
                              ROLLBACK;
                              V_ERRO := SQLERRM(SQLCODE);
                              INSERE_LOGITEM(V_SEQLOGITEM);

                              IF V_SEQLOGITEM != 0 THEN
                                 INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                                 VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                              END IF;

                              COMMIT;
                        END;
                     END LOOP;

                  END IF;

                  /* Gerar entrada no OL Armazenagem (V_CDFILWMSMHAARM) */
                  IF (V_ERRO IS NULL) THEN
                     /* Gera corpo nota fiscal de Entrada */
                     NOVO_CODIGO_SC('LANCNFPROD/FILIAL' || V_CDFILWMSMHAARM, V_NFE_NRLANCTO);
                     NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILWMSMHAARM, V_NFE_NRLANCTO);
                     NOVO_CODIGO_SC('LANCTOEST'    ||V_CDFILWMSMHAARM, V_NFE_NRLANCESTQ);

                     V_NFE_NRLANCTO   := SUBSTR(V_NFE_NRLANCTO,   -10);
                     V_NFE_NRLANCESTQ := SUBSTR(V_NFE_NRLANCESTQ, -10);

                     SELECT CDSERIE, CDINSCESTA, CDEMPRESA
                       INTO V_NFE_SERIE, V_CDINSCESTAREM, V_NFE_CDEMPRESA
                       FROM FILIAL
                      WHERE CDFILIAL = V_CDFILWMSMHAARM;

                     SELECT VRNOTAFISC
                       INTO V_NFE_VRNOTAFISC
                       FROM NOTAFISCAL
                      WHERE CDFILIAL    = V_CDFILIALOL
                        AND NRLANCTONF = V_NFS_NRLANCTO;

                     BEGIN
                        GERA_NOTAFISCAL_CORPO_ENTRADA (P_CDFILIAL    => V_CDFILWMSMHAARM,
                                                       P_CDFILIRECE  => V_CDFILWMSMHAARM,
                                                       P_CDEMPRESA   => V_NFE_CDEMPRESA,
                                                       P_CDTIPOOPER  => '93',
                                                       P_CDSERIEENTR => V_NFE_SERIE,
                                                       P_CDCLIENTE   => V_CDFILIALOL,
                                                       P_DTENTRSAID  => TO_DATE(V_DATAINCL),
                                                       P_IDSISTEMA   => 'DFE',
                                                       P_VRNOTAFISC  => V_NFE_VRNOTAFISC,
                                                       P_PRXLANCTONF => V_NFE_NRLANCTO,
                                                       P_PRXLANCESTQ => V_NFE_NRLANCESTQ,
                                                       P_NRLANCTONF  => V_NFE_NRLANCTO,
                                                       P_NRLANCESTQ  => V_NFE_NRLANCESTQ);

                     EXCEPTION
                        WHEN OTHERS THEN
                           V_NFE_NRLANCESTQ := NULL;
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                           INSERE_LOGITEM(V_SEQLOGITEM);

                           IF V_SEQLOGITEM != 0 THEN
                              INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                              VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                           END IF;

                           COMMIT;
                     END;

                     -- Buscar itens da NF de entrada para gerao da Remessa
                     FOR C_PRODREM IN (SELECT CDPRODUTO,    CDPRODEMIS, DSPRODEMIS,
                                              VRUNITITEM,   VRDESCITEM, QTITEMPROD
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL   = V_CDFILIAL
                                          AND NRLANCTONF = V_NRLANCTO) LOOP
                        BEGIN
                        GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_CDFILWMSMHAARM,
                                                P_NRLANCTONF   => V_NFE_NRLANCTO,
                                                P_CDPRODUTO    => C_PRODREM.CDPRODUTO,
                                                P_CDPRODEMIS   => C_PRODREM.CDPRODEMIS,
                                                P_DSPRODEMIS   => C_PRODREM.DSPRODEMIS,
                                                P_VRUNITITEM   => C_PRODREM.VRUNITITEM,
                                                P_VRDESCITEM   => C_PRODREM.VRDESCITEM,
                                                P_QTITEMPROD   => C_PRODREM.QTITEMPROD);
                         EXCEPTION
                            WHEN OTHERS THEN
                               ROLLBACK;
                               V_ERRO := SQLERRM(SQLCODE);
                               INSERE_LOGITEM(V_SEQLOGITEM);

                               IF V_SEQLOGITEM != 0 THEN
                                  INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                                  VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                               END IF;

                               COMMIT;
                         END;
                     END LOOP;
                     -- Gravar impostos para os itens da nota fisca de entrada
                     FOR C_PRODREM IN (SELECT I.CDPRODUTO,  I.CDPRODEMIS,  I.DSPRODEMIS,
                                              I.VRUNITITEM, I.VRDESCITEM,  P.CDARVPROD,
                                              I.QTITEMPROD, I.NRSEQITPROD, I.VRTOTAITEM
                                         FROM ITEMPRODUTO I, PRODUTO P
                                        WHERE CDFILIAL    = V_CDFILWMSMHAARM
                                          AND NRLANCTONF  = V_NFE_NRLANCTO
                                          AND I.CDPRODUTO = P.CDPRODUTO) LOOP

                        CONSULTA_GRUPOFISCAL (P_IDORIGDESTNF => 'L',
                                              P_CDORIGDESTNF => V_CDFILWMSMHAARM,
                                              P_CDFILIFATUR  => V_CDFILWMSMHAARM,
                                              P_IDENTRSAIDOP => 'E',
                                              P_CDTIPOOPER   => '93',
                                              P_CDGRUPOFISC  => V_CDGRUPOFISC);

                        IMPOSTO_ENTRADA_PRODUTO(P_EMPRESA      => V_NFE_CDEMPRESA,
                                                P_INSCESTA     => V_CDINSCESTAREM,
                                                P_TIPOOPER     => '93',
                                                P_CDFORNECED   => '',
                                                P_FILIAL       => V_CDFILWMSMHAARM,
                                                P_LANCTONF     => V_NFE_NRLANCTO,
                                                P_INIVALID     => TO_DATE(V_DATAINCL),
                                                P_ENTRSAID     => 'E',
                                                P_CDGRUPOFISC  => V_CDGRUPOFISC,
                                                P_IDINTEREST   => 'N',
                                                P_CDARVPROD    => C_PRODREM.CDARVPROD,
                                                P_CDGRPFISCSV  => '',
                                                P_IDORIGDESTNF => 'L',
                                                P_CDFILIRECE   => V_CDFILWMSMHAARM,
                                                P_CDFILIEMIT   => V_CDFILIALOL,
                                                P_CDCLIENTE    => '',
                                                P_VRPRODUTO    => C_PRODREM.VRTOTAITEM);

                        FOR C_ALIQITEM IN(SELECT IM.CDIMPOSTO, IM.SGIMPOSTO, IM.IDTRATIMPO, IM.IDPREIMPENTR,
                                                 I.CDFISCTEMP, NVL(AL.VRALIQUTMP, 0) AS VRALIQUOTA
                                            FROM INCITEMP I, IMPOSTO IM, ALIQTEMPPROD AL
                                           WHERE I.CDIMPOTEMP  = IM.CDIMPOSTO
                                             AND I.NRINCITEMP  = V_CDFILWMSMHAARM||V_NFE_NRLANCTO
                                             AND I.NRINCITEMP  = AL.NRALIQTEMP(+)
                                             AND I.CDIMPOTEMP  = AL.CDIMPOTEMP(+)
                                             AND IM.IDPRODNOTA <> 'C') LOOP


                              INSERT INTO TRABITPROIMPOS
                                 (CDFILIMPOIT,  NRLANCIMPOIT,   NRSEQIMPOIT,   CDIMPOSTOIT,
                                  VRCONTIMPOIT, VRREDBCIMPOIT,  VRBCALCIMPOIT, VRALIQIMPOIT,
                                  VRPDEDIMPOIT, VRIMPOSIT,      CDFISCIMPOIT,  NRSEQITPRO,
                                  IDVALORINFO,  VR1REDBCIMPOIT, IDTRIMPSTTI,   VRIMPOSVISUIT)

                              VALUES
                                 (V_CDFILWMSMHAARM, V_NFE_NRLANCTO,  C_PRODREM.NRSEQITPROD, C_ALIQITEM.CDIMPOSTO,
                                 (C_PRODREM.VRTOTAITEM - C_PRODREM.VRDESCITEM), 0, C_PRODREM.VRTOTAITEM, C_ALIQITEM.VRALIQUOTA,
                                  0, 0, C_ALIQITEM.CDFISCTEMP, '1',
                                  'N', 0, '0', 0);

                        END LOOP;
                        DELETE
                          FROM ALIQTEMPPROD
                         WHERE NRALIQTEMP = V_CDFILWMSMHAARM||V_NFE_NRLANCTO;

                        DELETE
                          FROM INCITEMP
                         WHERE NRINCITEMP = V_CDFILWMSMHAARM||V_NFE_NRLANCTO;

                     END LOOP;

                     FOR C_TRABIMPOSNFTOT IN (SELECT SUM(T.VRIMPOSIT) VRTOTAIMPO, T.CDIMPOSTOIT
                                 FROM TRABITPROIMPOS T, IMPOSTO I
                                WHERE CDFILIMPOIT  = V_CDFILWMSMHAARM
                                  AND NRLANCIMPOIT = V_NFE_NRLANCTO
                                  AND IDPRODNOTA <> 'C'
                                  AND T.CDIMPOSTOIT = I.CDIMPOSTO
                                GROUP BY CDIMPOSTOIT
                                ORDER BY CDIMPOSTOIT)LOOP

                         INSERT INTO TRABIMPOSNFTOT
                                    (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT)

                              VALUES(V_CDFILWMSMHAARM, V_NFE_NRLANCTO, C_TRABIMPOSNFTOT.CDIMPOSTOIT, (0 + C_TRABIMPOSNFTOT.VRTOTAIMPO), 0);
                     END LOOP;

                     BEGIN
                        GERA_FECHAMENTO_NFENTRADA(P_CDFILIAL   => V_CDFILWMSMHAARM,
                                                  P_NRLANCTONF => V_NFE_NRLANCTO,
                                                  P_DATAPROC   => TO_DATE(V_DATAINCL),
                                                  P_NRLANCESTQ => V_NFE_NRLANCESTQ);
                     EXCEPTION
                        WHEN OTHERS THEN
                           ROLLBACK;
                           V_ERRO := SQLERRM(SQLCODE);
                           INSERE_LOGITEM(V_SEQLOGITEM);

                           IF V_SEQLOGITEM != 0 THEN
                              INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                              VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                           END IF;
                           COMMIT;
                     END;

                     IF (V_ERRO IS NULL) THEN
                        ATUALIZA_ESTOQUE(V_CDFILWMSMHAARM, TO_DATE(V_DATAINCL), TO_DATE(SYSDATE), V_CDFILWMSMHAARM, V_NFE_NRLANCESTQ);

                        /* Atualizar a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
                        FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                                   CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                                              FROM MOVILOTE
                                             WHERE NRMOVILOTE = V_CDFILWMSMHAARM||V_NFE_NRLANCESTQ
                                               AND CDFILIAL   = V_CDFILWMSMHAARM) LOOP
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ  = 'N'
                            WHERE CDFILIAL     = V_CDFILWMSMHAARM
                              AND NRLANCESTQ   = V_NFE_NRLANCESTQ
                              AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
                              AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
                              AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
                              AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
                              AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

                           V_ERRO := 'Nota Fiscal de remessa entrada. Algum(ns) produto(s) tornariam o estoque irregular.';
                        END LOOP;

                        DELETE MOVILOTE
                         WHERE NRMOVILOTE = V_CDFILWMSMHAARM||V_NFE_NRLANCESTQ;

                        --COMMIT;
                     END IF;
                     /* Gravar documento de sada que deu origem a entrada*/
                     UPDATE NOTAFISCAL
                        SET IDDOCREPLIC = V_CDFILIALOL||V_NFS_NRLANCTO
                      WHERE CDFILIAL    = V_CDFILWMSMHAARM
                        AND NRLANCTONF  = V_NFE_NRLANCTO;


                     /* Gravar dados adicionais */
                     IF (V_ERRO IS NULL) THEN

                        FOR C_DADOSADIC IN (SELECT N.NRINSJURNF, N.NRNOTAFISC,
                                                   T.NMTIPOOPER AS OPERACAO, N.DTENTRSAID
                                              FROM NOTAFISCAL N, TIPOOPERAC T
                                             WHERE N.CDFILIAL     = V_CDFILIAL
                                               AND N.NRLANCTONF   = V_NRLANCTO
                                               AND N.CDTIPOOPER   = T.CDTIPOOPER
                                               AND N.IDENTRSAIDOP = T.IDENTRSAIDOP) LOOP

                           BEGIN
                           GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    => V_CDFILIALOL,
                                                   P_NRLANCTONF  => V_NFS_NRLANCTO,
                                                   P_DTINICIO    => SYSDATE,
                                                   P_DTFINAL     => SYSDATE,
                                                   P_MENSAGEM    => 'NF referente a '||C_DADOSADIC.OPERACAO||
                                                                    ' do fornecedor '||C_DADOSADIC.NRINSJURNF||
                                                                    ' NF: '||C_DADOSADIC.NRNOTAFISC|| ' - '||
                                                                    TO_CHAR(C_DADOSADIC.DTENTRSAID, 'DD/MM/YYYY'));

                           GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    => V_CDFILWMSMHAARM,
                                                      P_NRLANCTONF  => V_NFE_NRLANCTO,
                                                      P_DTINICIO    => SYSDATE,
                                                      P_DTFINAL     => SYSDATE,
                                                      P_MENSAGEM    => 'NO INCIDENCIA DO ICMS ART7, INCISO II DO RICMS/SP');

                           EXCEPTION
                              WHEN OTHERS THEN
                                 ROLLBACK;
                                 V_ERRO := SQLERRM(SQLCODE);
                                 INSERE_LOGITEM(V_SEQLOGITEM);

                                 IF V_SEQLOGITEM != 0 THEN
                                    INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                                    VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                                 END IF;

                                 COMMIT;
                           END;
                        END LOOP;


                     END IF;

                  END IF;
              -- ELSE
           --       V_ERRO := 'Filial OL(Armazenagem) no informada';
               END IF;
            END IF;
         END IF;
      END IF;

      IF (V_ERRO IS NULL) THEN
         V_DIFERENCA := 0;
         BEGIN
            SELECT CDPRODUTO
              INTO V_CDPRODUTO
              FROM PRODUTO
             WHERE CDARVPROD = V_CDARVPROD;
         EXCEPTION
            WHEN OTHERS THEN
               V_CDPRODUTO := NULL;
               V_ERRO      := 'Produto '||V_CDARVPROD||' no encontrado';
         END;

         IF (V_CDPRODUTO IS NOT NULL) THEN
            BEGIN
               SELECT I.QTITEMPROD, I.CDPRODEMIS, I.DSPRODEMIS, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.VRUNITITEM, I.VRDESCITEM,
                      I.NRLOTEESTQ, I.NRSUBLOTE
                 INTO V_QTITEMPROD, V_CDPRODEMIS, V_DSPRODEMIS, V_CDALMOXARIFE, V_CDLOCALESTOQ, V_VRUNITITEM, V_VRDESCITEM,
                      V_NRLOTEESTQ, V_NRSUBLOTE
                 FROM ITEMPRODUTO I
                WHERE I.CDFILIAL    = V_CDFILIAL
                  AND I.NRLANCTONF  = V_NRLANCTO
                  AND I.NRSEQITPROD = LPAD(V_SEQITEM, 4, '0');

               V_DIFERENCA := V_QTITEMPROD - V_QUANTIDADE;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_ERRO := 'Produto '||V_CDARVPROD||' no encontrado no lanamento da nota';
            END;
         END IF;

         IF (V_DIFERENCA >= 1) THEN
            BEGIN
               SELECT MAX(QTESTOQDIA)--, MAX(DTPOSIESTQ)
                 INTO V_QTDEESTO--, V_DTPOSIESTQ
                 FROM POSESTDIA P
                WHERE P.CDFILIAL  = V_CDFILIALOL
                  AND P.CDPRODUTO = V_CDPRODUTO
                  AND P.QTESTOQDIA <> 0
                  AND P.DTPOSIESTQ <= (SELECT MAX(DTPOSIESTQ)
                                         FROM POSESTDIA
                                        WHERE CDFILIAL = P.CDFILIAL
                                          AND CDALMOXARIFE = P.CDALMOXARIFE
                                          AND CDLOCALESTOQ = P.CDLOCALESTOQ
                                          AND NRLOTEESTQ = P.NRLOTEESTQ
                                          AND NRSUBLOTE = P.NRSUBLOTE
                                          AND CDPRODUTO = P.CDPRODUTO
                                          AND DTPOSIESTQ <= TO_DATE(V_DATAINCL)+1);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_QTDEESTO := 0;
                  V_NRLANCESTQ := NULL;
            END;

            IF (V_QTDEESTO >= V_DIFERENCA) THEN
               BEGIN
                  IF (V_NRLANCDEVO IS NULL) THEN
                     V_CDFILIALDEVO := V_CDFILIAL;
                     V_NRLANCTODEVO := V_NRLANCTO;
                     NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILIAL, V_NRLANCDEVO);
                     NOVO_CODIGO_SC('LANCTOEST'    ||V_CDFILIAL, V_NRLANCESTQ);

                     V_NRLANCDEVO := SUBSTR(V_NRLANCDEVO, -10);
                     V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, -10);

                     SELECT CDSERIE, CDINSCESTA
                       INTO V_NRSERIE, V_CDINSCESTA_OL
                       FROM FILIAL
                      WHERE CDFILIAL = V_CDFILIALOL;


                     IF (V_IDORIGDESTNF = 'F') THEN
                        V_CDTIPOOPER := '06';
                     ELSE
                        V_CDFORNECED := V_CDFILIEMIT;

                        IF (V_CDINSCESTA = V_CDINSCESTA_OL) THEN
                           V_CDTIPOOPER := '04';
                        ELSE
                           V_CDTIPOOPER := '02';
                        END IF;
                     END IF;

                     BEGIN
                        GERA_NOTAFISCAL_CORPO(P_CDFILIAL    => V_CDFILIAL,
                                              P_CDFILIEMIT  => V_CDFILIALOL,
                                              P_CDEMPRESA   => V_EMPRESA,
                                              P_CDTIPOOPER  => V_CDTIPOOPER,
                                              P_DTENTRSAID  => TO_DATE(V_DATAINCL),
                                              P_IDSISTEMA   => 'DFS',
                                              P_PRXLANCTONF => V_NRLANCDEVO,
                                              P_PRXLANCESTQ => V_NRLANCESTQ,
                                              P_CDSERIE     => V_NRSERIE,
                                              P_CDCLIENTE   => V_CDFORNECED,
                                              P_NRLANCTONF  => V_NRLANCDEVO,
                                              P_NRLANCESTQ  => V_NRLANCESTQ);
                      EXCEPTION
                         WHEN OTHERS THEN
                            V_NRLANCESTQ := NULL;
                            ROLLBACK;
                            V_ERRO := SQLERRM(SQLCODE);
                            INSERE_LOGITEM(V_SEQLOGITEM);

                            IF V_SEQLOGITEM != 0 THEN
                               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                               VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                            END IF;

                            COMMIT;
                      END;

                  END IF;

                  IF (V_NRLANCESTQ IS NOT NULL) THEN
                     V_CONT := V_CONT + 1;
                     BEGIN
                     GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => V_CDFILIAL,
                                             P_NRLANCTONF   => V_NRLANCDEVO,
                                             P_CDPRODUTO    => V_CDPRODUTO,
                                             P_CDPRODEMIS   => V_CDPRODEMIS,
                                             P_DSPRODEMIS   => V_DSPRODEMIS,
                                             P_VRUNITITEM   => V_VRUNITITEM,
                                             P_VRDESCITEM   => V_VRDESCITEM,
                                             P_CDALMOXARIFE => V_CDALMOXARIFE,
                                             P_CDLOCALESTOQ => V_CDLOCALESTOQ,
                                             P_NRLOTEESTQ   => V_NRLOTEESTQ,
                                             P_NRSUBLOTE    => V_NRSUBLOTE,
                                             P_QTITEMPROD   => V_DIFERENCA);
                      EXCEPTION
                         WHEN OTHERS THEN
                            ROLLBACK;
                            V_ERRO := SQLERRM(SQLCODE);
                            INSERE_LOGITEM(V_SEQLOGITEM);

                            IF V_SEQLOGITEM != 0 THEN
                               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                               VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
                            END IF;

                            COMMIT;
                      END;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                     V_NRLANCESTQ := NULL;
                     V_ERRO       := SQLERRM(SQLCODE);
                     ROLLBACK;
               END;
            ELSE
               V_ERRO := 'Quantidade do produto '||V_CDARVPROD|| '  insuficiente para a devoluo. ';
               V_ERRO := V_ERRO||' Quantidade atual: '||V_QTDEESTO||'. Quantidade a ser devolvida: '||V_DIFERENCA;
            END IF;
         END IF;

         IF (V_ERRO IS NOT NULL) THEN
            INSERE_LOGITEM(V_SEQLOGITEM);

            IF V_SEQLOGITEM != 0 THEN
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
            END IF;
         END IF;
      ELSE
         INSERE_LOGITEM(V_SEQLOGITEM);

         IF V_SEQLOGITEM != 0 THEN
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
         END IF;
      END IF;
   END LOOP;

   P_ERRO := V_ERRO;
   IF (V_ERRO IS NULL) THEN
      INSERE_LOGITEM(V_SEQLOGITEM);

      IF V_SEQLOGITEM != 0 THEN
         INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
         VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
      END IF;
   END IF;

   UPDATE USR_LOG_INTEGRACAO
      SET HORAREC = SYSDATE
    WHERE SEQLOG = P_SEQLOG;

   COMMIT;
   CLOSE C_XML;
EXCEPTION
   WHEN OTHERS THEN
     V_ERRO := SUBSTR(SQLERRM(SQLCODE),1,4000);

      FOR C_EXCEPT IN (SELECT EMPRESA, FILIAL, DATAINCLUSAO, CODPEDIDOCOMPRA, CODAGENTE, NFENTRADA,
                              NFSERIE, SEQITEM, CODPRODUTO, QUANTIDADE, CODUNIDADE
                         FROM RETORNO_PEDIDO_OC
                        WHERE CODPEDIDOCOMPRA = V_CODPEDIDO)
      LOOP
         INSERT INTO EXCP_RET_NF(EMPRESA, FILIAL, DATAINCLUSAO, CODPEDIDOCOMPRA, CODAGENTE, NFENTRADA,
                                 NFSERIE, SEQITEM, CODPRODUTO, QUANTIDADE, CODUNIDADE, EXCECAO)
         VALUES(C_EXCEPT.EMPRESA, C_EXCEPT.FILIAL, C_EXCEPT.DATAINCLUSAO, C_EXCEPT.CODPEDIDOCOMPRA, C_EXCEPT.CODAGENTE, C_EXCEPT.NFENTRADA,
                C_EXCEPT.NFSERIE, C_EXCEPT.SEQITEM, C_EXCEPT.CODPRODUTO, C_EXCEPT.QUANTIDADE, C_EXCEPT.CODUNIDADE, V_ERRO);
      END LOOP;
      COMMIT;

      IF C_XML%ISOPEN THEN
         CLOSE C_XML;
      END IF;
      INSERE_LOGITEM(V_SEQLOGITEM);
      V_ERRO := SQLERRM(SQLCODE);
      P_ERRO := V_ERRO;

      IF V_SEQLOGITEM != 0 THEN
         INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
         VALUES(V_TABELA, V_CODPEDIDO, V_ERRO, '1', V_SEQLOGITEM);
      END IF;
      COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('MHA_IMPORTA_RET_NOTAFISCAL','5.87.XXX'); END;
/
